//"Palm DB File descriptions" content plugin for TC 6.50
//Set .wdx type:
{$E wdx}
library wdx_PdbDiz;

uses
  Windows, ContPlug, SysUtils;

const
  _DetectString: PAnsiChar = 'EXT="PDB"|EXT="PRC"';
//  _DetectString: PAnsiChar = '';

  _descChar: AnsiString = ' ';
//  _extExe: AnsiString = 'exe dll sys bpl ocx ax wdx wfx wcx wlx';
//  
  _FieldsNum = 8;
  _Fields: array[0.._FieldsNum-1] of PAnsiChar = (
    'DBName',
    'DBType',
    'CreatorID',
    'DataCreated',
    'DataModified',
    'DataBackedUp',
    'NumRecords',
    'Version');

    MAX_DB_NAME_LENGTH = 31;
type

    TDateTime = type Double;
    //////////////////////////////////////////////////////////////
    //Record type for the database header (common to PDB and PRC)
    TPDBHeaderNative = packed record
        Name: array[0..MAX_DB_NAME_LENGTH] of AnsiChar;
        Flags, Version: Word;
        Created, Modified, BackedUp: Longint;
        Modification, AppInfoArea, SortInfoArea: Longint;
        DBType, CreatorID: array[0..3] of AnsiChar;
        IDSeed, NextRecordList: Longint;
        NumRecords: Word;
    end;

    //////////////////////////////////////////////////////////////
    //TPDBHeader
    //
    //The database header (for PDB and PRC)
    TPDBHeader = record
        Name: AnsiString;
        ReadOnly, Dirty, Backup, Overwrite, ForceReset, NoBeam: Boolean;
        //DBFlags: TDBFlags;
        Version: Integer;
        Created, Modified, BackedUp: TDateTime;
        Modification, AppInfoArea, SortInfoArea: Integer;
        DBType, CreatorID: AnsiString;
        IDSeed, NextRecordList: Integer;
        NumRecords: Integer;
    end;
//Convert the Motorola format Lontint to the Intel format
 function SwapLongInt(L: Longint): longint;
 begin
    result := swap(L shr 16) or (longint(swap(L and $ffff)) shl 16);
 end;
//Delphi determines the date/time based on days since 12/30/1899
//Palm determines the date/time based on seconds since 1/1/1904
 function PalmToTDateTime(Seconds: Cardinal): TDateTime;
 var
    Days, Remainder : Integer;
//This function doesn't work right
//It was translating 1999 dates to 1933, not sure why, this ErrorOffset
//kludge fixes it pretty well... ErrorOffset gets us to 1/1/1970
//(Unix time).  I don't question it, I just use it...
 const
    ErrorOffset = 2082844800;  //seconds
 begin
    Inc(Seconds, ErrorOffset);
    //1462 is the number of days between 12/30/1899 and 1/1/1904
    Inc(Seconds, (1462 * 86400));
    Days := Seconds div 86400;
    Remainder := Seconds mod 86400;
    Result := Days + (Remainder / 86400);
 end;
 //This probably doesn't work right either...
 function TDateTimeToPalm(DateTime: TDateTime): Cardinal;
 const
    ErrorOffset = 2082844800;  //Seconds
 var
    Days: Integer;
 begin
    Days := Round(Int(DateTime)) - 1462;
    Result := Days * 86400 + Round((frac(DateTime) / 86400)) - ErrorOffset;
 end;


function GetDBName(const fn: string; n: integer): AnsiString;
var
  f: file of TPDBHeaderNative;
  DBHeaderNative: TPDBHeaderNative;
  DBHeader:TPDBHeader;
begin {main}
  Result:= '';
  {$I-}
  AssignFile(f, fn);
  Reset(f);
  if IOResult<>0 then Exit;
  {$I+}
  Read(f, DBHeaderNative);
  CloseFile(f);
  try
        //Assign the native types to Delphi types
        DBHeader.Name := DBHeaderNative.Name;
        SetLength(DBHeader.Name,32);
        //Remember, the bytes are swapped on Intel
        DBHeaderNative.Flags := Swap(DBHeaderNative.Flags);
        DBHeader.ReadOnly := Boolean(DBHeaderNative.Flags and $0002);
        DBHeader.Dirty := Boolean(DBHeaderNative.Flags and $0004);
        DBHeader.Backup := Boolean(DBHeaderNative.Flags and $0008);
        DBHeader.Overwrite := Boolean(DBHeaderNative.Flags and $0010);
        DBHeader.ForceReset := Boolean(DBHeaderNative.Flags and $0020);
        DBHeader.NoBeam := Boolean(DBHeaderNative.Flags and $0040);
        DBHeader.Version := Swap(DBHeaderNative.Version);
        DBHeader.Created := PalmToTDateTime(SwapLongInt(DBHeaderNative.Created));
        DBHeader.Modified := PalmToTDateTime(SwapLongInt(DBHeaderNative.Modified));
        DBHeader.BackedUp := PalmToTDateTime(SwapLongInt(DBHeaderNative.BackedUp));
        DBHeader.Modification := SwapLongInt(DBHeaderNative.Modification);
        DBHeader.AppInfoArea := SwapLongInt(DBHeaderNative.AppInfoArea);
        DBHeader.SortInfoArea := SwapLongInt(DBHeaderNative.SortInfoArea);
        DBHeader.DBType := DBHeaderNative.DBType;
        DBHeader.CreatorID := DBHeaderNative.CreatorID;
        DBHeader.IDSeed := SwapLongInt(DBHeaderNative.SortInfoArea);
        DBHeader.NextRecordList := SwapLongInt(DBHeaderNative.SortInfoArea);
        DBHeader.NumRecords := Swap(DBHeaderNative.NumRecords);
  except
        n:=-1;
  end;
  case n of
  0: Result:= DBHeader.Name+_descChar;
  1: Result:= DBHeader.DBType+_descChar;
  2: Result:= DBHeader.CreatorID+_descChar;
  3: Result:= DateToStr(DBHeader.Created)+_descChar;
  4: Result:= DateToStr(DBHeader.Modified)+_descChar;
  5: Result:= DateToStr(DBHeader.BackedUp)+_descChar;
  6: Result:= IntToStr(DBHeader.NumRecords)+_descChar;
  7: Result:= IntToStr(DBHeader.Version)+_descChar;
  else
    Result:= '';
  end;
end;
// 
function GetDBDate(const fn: string; n: integer): TDateTime;
var
  f: file of TPDBHeaderNative;
  DBHeaderNative: TPDBHeaderNative;
  DBHeader:TPDBHeader;
begin {main}
  Result:= 0;
  {$I-}
  AssignFile(f, fn);
  Reset(f);
  if IOResult<>0 then Exit;
  {$I+}
  Read(f, DBHeaderNative);
  CloseFile(f);
  try
        DBHeader.Version := Swap(DBHeaderNative.Version);
        DBHeader.Created := PalmToTDateTime(SwapLongInt(DBHeaderNative.Created));
        DBHeader.Modified := PalmToTDateTime(SwapLongInt(DBHeaderNative.Modified));
        DBHeader.BackedUp := PalmToTDateTime(SwapLongInt(DBHeaderNative.BackedUp));
        DBHeader.NumRecords := Swap(DBHeaderNative.NumRecords);
  except
        n:=-1;
  end;
  case n of
  3: Result:= (DBHeader.Created);
  4: Result:= (DBHeader.Modified);
  5: Result:= (DBHeader.BackedUp);
  else
    Result:= 0;
  end;
end;
//--------------------------------------------
procedure ContentGetDetectString(DetectString: PAnsiChar; maxlen: integer); stdcall;
begin
  StrLCopy(DetectString, _DetectString, MaxLen - 1);
end;

//--------------------------------------------
function ContentGetSupportedField(FieldIndex: integer; FieldName: PAnsiChar;
  Units: PAnsiChar; maxlen: integer): integer; stdcall;
begin
  if (FieldIndex<0) or (FieldIndex>=_FieldsNum) then
    begin Result:= FT_NOMOREFIELDS; Exit end;

  StrLCopy(FieldName, _Fields[FieldIndex], MaxLen-1);
  StrCopy(Units, '');

  Result:= FT_STRING;
end;


//--------------------------------------------
{
function GetDesc(const fn: AnsiString; descType: integer): AnsiString;
var
  ext: AnsiString;
begin
  Result:= '';
  ext:= LowerCase(ExtractFileExt(fn));

  if (ext='pdb') or (ext='prc') then
    Result:= GetDBName(fn, descType);

end;
}
//--------------------------------------------
function ContentGetValueW(fn: PWideChar; FieldIndex, UnitIndex: integer;
  FieldValue: PByte; MaxLen, Flags: integer): integer; stdcall;
var
  s: AnsiString;
  ext: string;
  d: TDateTime;
  Year,Month,Day:WORD;
begin

  if (FieldIndex<0) or (FieldIndex >= _FieldsNum) then
    begin Result:= FT_NOSUCHFIELD; Exit end;

  ext:= LowerCase(ExtractFileExt(fn));

  if (Flags and CONTENT_DELAYIFSLOW)>0 then
    if (ext<>'') then begin Result:= FT_DELAYED; Exit end;

//  ext:= LowerCase(ExtractFileExt(fn));
  if (Pos('pdb',ext)>0) or (Pos('prc',ext)>0) then //Description fields
    begin
      if (FieldIndex in [3,4,5]) then //Data
      begin
        d:= GetDBDate(fn, FieldIndex);
        if d=0
          then
            Result:= FT_FIELDEMPTY
          else
          begin
            DecodeDate(d,Year,Month,Day);
            pdateformat(FieldValue).wYear:=Year;
            pdateformat(FieldValue).wMonth:=Month;
            pdateformat(FieldValue).wDay:=Day;
            Result:= FT_DATE;
          end
        end
      else      //AnsiString
      begin
  //    s:= GetDesc(fn, FieldIndex);
        s:= GetDBName(fn, FieldIndex);
        if s=''
          then
            Result:= FT_FIELDEMPTY
          else
          begin
            StrLCopy(PAnsiChar(FieldValue), PAnsiChar(s), MaxLen-1);
            Result:= FT_STRING;
          end
       end;
     end
  else
    begin Result:= FT_DELAYED; Exit end;
end;

function ContentGetValue(fn: PAnsiChar; FieldIndex, UnitIndex: integer;
  FieldValue: PByte; MaxLen, Flags: integer): integer; stdcall;
begin
  Result := ContentGetValueW(PWideChar(WideString(fn)), FieldIndex, UnitIndex, FieldValue, MaxLen, Flags);
end;

exports
  ContentGetDetectString,
  ContentGetSupportedField,
  ContentGetValueW,
  ContentGetValue;

end.
